;'Searching X:\... rasomas CalcFiles pradzioje, ten yra komentaras.
;nereikia - ismesk, cia kad matytusi, kur iesko.

model small
stack 2000h
jumps

DIRMAX equ 255

;----------------------------------------------

data segment

BannerMsg db 'Si programyte randa katalogus, kuriuose failu yra daugiau, negu', 13, 10
 	  db 'programos paleidimo kataloge.', 10, 13, 36
	

InDiskMsg db 'Iveskite disko pavadinima: $'
InDiskErrMsg db 'Toks diskas neegzistuoja!', 7, 13, 10, 36
InDiskName db 2, 0, 2 dup ( 0 );

StartupDir db 'A:\', ( DIRMAX - 3 ) dup ( 0 )
StartupDisk db 0

StartupPath db DIRMAX dup ( 0 )


WorstMsg db 13, 10, 'Daugiausiai veltui uzimantis katalogas: $'
WorstDir db DIRMAX dup ( 0 )

ClusterSize dw 0
FindPattern db '*.*', 0
TmpDir db 'A:\', ( DIRMAX - 3 ) dup (0)

MaxSlack dd 0
TotalSize dd 0
;NumFiles dw 0
RootFiles dw 0


OldDTA dd 0

DTARoot label

DTARootInternal db 21 dup ( 0 )
DTARootAttr db 0
DTARootFill db 126 dup (0 )

TryMsg db 'Searching $'

data ends


;---------------------------------------------------------------------


code segment 'text'
assume cs: code, ds:data


CalcFiles proc near

dta	 	equ byte ptr [bp+0]
dta_attrib    	equ byte ptr [bp+21] 
dta_size	equ word ptr [bp+26]
dta_size2	equ word ptr [bp+28]
dta_filename    equ byte ptr [bp+30]

old_dta_offset  equ word ptr [bp+128]
old_dta_segment equ word ptr [bp+130]

	slack_1 equ word ptr [bp+132]
	slack_2 equ word ptr [bp+134]

NumFiles equ word ptr [bp+136]

;---------------------------------------------

	push bp
	sub sp, 138
	mov bp, sp

	mov slack_1, 0
	mov slack_2, 0
	mov NumFiles, 0
;--------------------
;cia parasoma 'Searching ... '

	mov ah, 9
	mov dx, offset TryMsg
	int 21h

	mov di, offset TmpDir
	call PrintStrZ
;--------------------

	mov ah, 3bh               ;chdir
	mov dx, offset TmpDir 
	int 21h
	jc @@csExit

;--------------

	mov ah, 2fh              ;DTA 
	int 21h

	mov old_dta_offset, bx
	mov bx, es
	mov old_dta_segment, bx

	push ds

	mov dx, ss
	mov ds, dx
	mov dx, bp

	mov ah, 1ah
	int 21h

	pop ds

;--------

	mov ah, 4eh                 ;findfirst
	mov cx, 00110111b
	mov dx, offset FindPattern
	int 21h
	jc @@csExitDTA


@@csFoundItem:

	mov al, dta_attrib
	and al, 00010000b
	jnz @@csDir


	mov ax, dta_size
	xor dx, dx
	mov cx, 2000h
	div cx

	sub cx, dx

	mov ax, slack_1
	mov dx, cx
	add ax, dx
	mov slack_1, ax
	mov ax, slack_2
	mov dx, 0
	adc ax, dx
	mov slack_2, ax


	mov dx, dta_size
	mov ax, word ptr TotalSize
	add ax, dx
	mov word ptr TotalSize, ax
	mov ax, word ptr [TotalSize+2]	
	mov dx, dta_size2
	adc ax, dx
	mov word ptr [TotalSize+2], ax

	inc NumFiles

	jmp @@csFindNextItem


@@csDir:  
	cmp dta_filename, '.'
	je @@csFindNextItem

;-------------------
				   ; strcat( TmpDir, new )
	cld
	mov dx, ds
	mov es, dx
	mov di, offset TmpDir
	mov cx, 256
	mov al, 0
	repnz scasb
	jnz @@csDir
	dec di
	mov si, offset TmpDir + 3
	cmp si, di
	je @@csNS
	mov byte ptr [di],'\'
	inc di

@@csNS:
	lea si, dta_filename

@@csAdd:
	mov al, byte ptr ss:[si]
	mov byte ptr [di], al
	inc di
	inc si
	cmp al, 0
	jne @@csAdd

;--------------------------

	dec di
	push di

	call CalcFiles

	pop di
	dec di

;--------------------------

	mov si, offset TmpDir + 3

@@csRestorePath:

	mov al, byte ptr [di]
	mov byte ptr [di], 0
	dec di
	cmp di, si
	jb @@csRestoredPath

	cmp al, '\'
	jne @@csRestorePath

@@csRestoredPath:

	mov ah, 3bh               ; chdir
	mov dx, offset TmpDir
	int 21h
	jc @@csExitDTA

;----------------------

@@csFindNextItem:

       mov ah, 4fh
       int 21h
       jc @@csExitDTA

       jmp @@csFoundItem

;-----------------

@@csExitDTA:
	
	push ds                   ;  DTA
	mov dx, old_dta_segment
	mov ds, dx
	mov dx, old_dta_offset
	mov ah, 1ah
	int 21h
	pop ds

;-----------------

	mov ax, word ptr [MaxSlack+2]
	cmp slack_2, ax
	jg @@csNewMax
	jne @@csExit 

	mov ax, word ptr [MaxSlack]
	cmp slack_1, ax
	jng @@csExit 
	
@@csNewMax:

	push es
	mov cx, 255
	mov si, offset TmpDir
	mov di, offset WorstDir
	push ds
	pop es
	rep movsb
	pop es	

	mov ax, slack_2
	mov word ptr [MaxSlack+2], ax	
	mov ax, slack_1
	mov word ptr [MaxSlack], ax

	mov ax, RootFiles
	cmp ax, NumFiles
	jnl @@csLessFiles

;	mov ax, NumFiles
;	mov RootFiles, ax

@@csLessFiles:

@@csExit:

	mov ax, RootFiles
	cmp ax, NumFiles
	jnl @@csLessFiles1

;	mov ah, 9
;	mov dx, offset TryMsg
;	int 21h

	mov di, offset TmpDir
	call PrintStrZ
	
;	mov ax, NumFiles
;	mov RootFiles, ax

@@csLessFiles1:

	add	sp,138
	pop	bp
	ret

CalcFiles endp

;=====================================================================

begin:

	mov ax, data
	mov ds, ax

	mov ah, 2fh
	mov bx, offset OldDTA
	mov es, word ptr [OldDTA+2]
	int 21h

	
	mov ah, 1ah
	mov dx, offset DTARoot
	int 21h

	call CountRoot

	mov ah, 1ah
	mov dx, offset OldDTA
	int 21h

	call SaveStartupParams

	mov dx, offset BannerMsg
	call Message

;	call GetDisk
;	jc InvalidDisk

;	call CheckDiskValid
;	jc InvalidDisk

	mov ah, 19h
	int 21h
	add al, 'A'
	mov byte ptr TmpDir, al

	mov ah, 47h
	mov dl, 0
	mov si, offset TmpDir+3
	int 21h
	

;	call GetDiskInformation
;	mov ClusterSize, cx

	call NewLine

	call CalcFiles

;	mov dx, offset WorstMsg
;	call Message

;	mov di, offset WorstDir
;	call PrintStrZ

	call RestoreStartupParams

	mov ax, 4c00h
	int 21h

InvalidDisk:

	mov dx, offset InDiskErrMsg
	call Message

	mov ax, 4c01h
	int 21h


;=========================================================================


GetStartupPath proc near


	mov ah, 47h
	mov dl, 0
	mov si, offset StartupPath
	int 21h

	ret

GetStartupPath endp


	

CountRoot proc near


	mov ax, data
	mov ds, ax

	mov ah, 4eh
	mov dx, offset FindPattern
	mov cx, 00110111b
	int 21h
	jc @@FullOblomas

	mov al, byte ptr DTARootAttr
	and al, 00010000b
	jnz @@oblomas

	inc RootFiles

@@findagain:
	mov ah, 4fh	
	int 21h
	jc @@FullOblomas

	mov al, DTARootAttr
	and al, 00010000b
	jnz @@oblomas

	inc RootFiles
	jmp @@findagain

@@oblomas:

	jmp @@findagain

@@FullOblomas:

	ret


CountRoot endp


	
SaveStartupParams proc near
	
	push ax dx si

	mov ah, 47h     ;pwd
	mov dl, 0
	mov si, offset StartupDir
	add si, 3
	int 21h
	jc @@sspErr

	mov ah, 19h     ;curdisk
	int 21h
	mov byte ptr StartupDisk, al
	add al, 'A'
	mov byte ptr StartupDir, al
	
	pop si dx ax

	clc
	ret

@@sspErr:
	stc
	ret

SaveStartupParams endp

;------------------------------------------------------------------------

RestoreStartupParams proc near

	push ax dx

	mov ah, 0eh
	mov dl, byte ptr StartupDisk
	int 21h

	mov ah, 3bh              ;chdir
	mov dx, offset StartupDir
	int 21h
	jc @@rspErr

	pop dx ax

	clc	
	ret

@@rspErr:
	stc
	ret

RestoreStartupParams endp

;-----------------------------------------------------------------------

;di - offs
PrintStrZ proc near

	pushf
	push es si di cx dx

	mov si, di

	cld
	push ds
	pop es
	mov al, 0
	mov cx, 255
	repne scasb
	je zero
	jmp no_zero

zero:
	dec di

	mov al, byte ptr [di]
	mov byte ptr [di], 13
	
	mov ah, byte ptr [di+1]
	mov byte ptr [di+1], 10

	mov bl, byte ptr [di+2]
	mov byte ptr [di+2], 36
	
	push ax bx

no_zero:
	mov ah, 9
	mov dx, si
	int 21h

	pop bx ax
	mov byte ptr [di], al
	mov byte ptr [di+1], ah
	mov byte ptr [di+2], bl

	pop dx cx di si es
	popf

	ret


PrintStrZ endp

;------------------------------------------------------------------------
comment#
Procedura GetDisk nuskaito is konsoles disko pavadinima ir patikrina, 
ar ivestas diskas yra 'A'..'Z'.
DL - ivestas diskas
NC - ok, CY - klaida
#

GetDisk proc near

	mov ah, 0ah
	mov dx, offset InDiskName
	int 21h

	mov dl, byte ptr [InDiskName + 2]	
	cmp dl, 'A'
	jb @@gdErr
	cmp dl, 'Z'
	jna @@gdOK

	cmp dl, 'a'
	jb @@gdErr
	cmp dl, 'z'
	ja @@gdErr
	
	sub dl, 'a'-'A'
	
@@gdOK:
	sub dl, 'A'
	clc
	ret	

@@gdErr:
	stc
	ret

GetDisk endp

;----------------------------------------------------------------------------
comment#
Procedura CheckDiskValid patikrina, ar tikrai DL diskas egzistuoja.
DL - diskas
NC - ok, CY - klaida
#

CheckDiskValid proc near

	push ax

	push dx

	mov ah, 0eh
	int 21h

	mov ah, 19h
	int 21h

	pop dx
	cmp dl, al
	jne @@cdvErr

	pop ax
	clc
	ret

@@cdvErr:
	pop ax
	stc
	ret

CheckDiskValid endp

;---------------------------------------------------------------------------

comment#
Procedura GetDiskInformation grazina dabartinio disko baitu skaiciu
klasteryje. 
CX - baitu klasteryje
#

GetDiskInformation proc near

	push ax bx dx ds

	mov ah, 1bh
	int 21h
	
	mul cx
	mov cx, ax

	pop ds dx bx ax
	
	ret

GetDiskInformation endp

;-----------------------------------------------------------------------

comment#

Procedura NewLine perveda kursoriu i kita eilute.
Pakeiciami registrai: nera.

#

NewLine proc near

	push ax dx

	mov ah, 6
	mov dl, 13
	int 21h

	mov dl, 10
	int 21h

	pop dx ax

	ret

NewLine endp

;-------------------------------------------------------------

comment#

Procedura Message isspausdina i konsole eilute, kurios adresas
yra registruose ds:dx.
Pakeiciami registrai: nera

#


Message proc near

	push ax 
	mov ah, 9
	int 21h
	pop ax
	ret

Message endp



code ends
end begin